#ifndef __ENSEMBLE_DENTIERS__
#define __ENSEMBLE_DENTIERS__
#include <errno.h>
#include "ListeChaineeDEntiers.h"
/* Partie privee */
typedef struct {
  LCDE_ListeChainee lesElements;
  int nbElements;
} EDE_Ensemble;

/* Partie publique */
#define EDE_ERREUR_MEMOIRE 1

EDE_Ensemble EDE_ensemble();
void EDE_ajouter(EDE_Ensemble*,int);  /* errno=EDE_ERREUR_MEMOIRE si pas assez de mmoire */
void EDE_retirer(EDE_Ensemble*,int);
int EDE_estPresent(EDE_Ensemble,int);
int EDE_cardinalite(EDE_Ensemble);
EDE_Ensemble EDE_union(EDE_Ensemble,EDE_Ensemble);  /* errno=EDE_ERREUR_MEMOIRE si pas assez de mmoire */
EDE_Ensemble EDE_intersection(EDE_Ensemble,EDE_Ensemble);  /* errno=EDE_ERREUR_MEMOIRE si pas assez de mmoire */
EDE_Ensemble EDE_soustraction(EDE_Ensemble,EDE_Ensemble);  /* errno=EDE_ERREUR_MEMOIRE si pas assez de mmoire */
void EDE_vider(EDE_Ensemble*); 
EDE_Ensemble EDE_copier(EDE_Ensemble);  /* errno=EDE_ERREUR_MEMOIRE si pas assez de mmoire */
int EDE_egale(EDE_Ensemble,EDE_Ensemble);
#endif 
