#ifndef __LISTE_CHAINEE_DENTIERS__
#define __LISTE_CHAINEE_DENTIERS__
#include <errno.h>

/* Partie privee */
typedef struct LCDE_Noeud* LCDE_ListeChainee;
typedef struct LCDE_Noeud {
	int lElement;
	LCDE_ListeChainee listeSuivante;
}  LCDE_Noeud;

/* Partie publique */
#define LCDE_ERREUR_MEMOIRE 1

LCDE_ListeChainee LCDE_listeChainee();
int LCDE_estVide(LCDE_ListeChainee);
void LCDE_ajouter(LCDE_ListeChainee*,int); /* errno=LCDE_ERREUR_MEMOIRE si pas assez de mmoire */
int LCDE_obtenirElement(LCDE_ListeChainee); /* assertion : liste non vide */
LCDE_ListeChainee LCDE_obtenirListeSuivante(LCDE_ListeChainee); /* assertion : liste non vide */
void LCDE_fixerListeSuivante(LCDE_ListeChainee*, LCDE_ListeChainee); /* assertion : liste non vide */
void LCDE_fixerElement(LCDE_ListeChainee*,int); /* assertion : liste non vide */
void LCDE_supprimerTete(LCDE_ListeChainee*); /* assertion : liste non vide */
void LCDE_supprimer(LCDE_ListeChainee*); 
LCDE_ListeChainee LCDE_copier(LCDE_ListeChainee);
int LCDE_egale(LCDE_ListeChainee,LCDE_ListeChainee);
#endif 
