#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>
#include <stdbool.h>
#include "ListeChaineeDEntiers.h"

LCDE_ListeChainee LCDE_listeChainee(){
  errno=0;
  return NULL;
}

int LCDE_estVide(LCDE_ListeChainee l) {
  errno=0;
  return (l==NULL);
}

void LCDE_ajouter(LCDE_ListeChainee* pl, int e) {
  LCDE_ListeChainee pNoeud=(LCDE_ListeChainee)malloc(sizeof(LCDE_Noeud));
  if (pNoeud!=NULL) {
      errno=0;
      pNoeud->lElement=e;
      pNoeud->listeSuivante=*pl;
      *pl=pNoeud;
  } else {
    errno=LCDE_ERREUR_MEMOIRE;
  }
}

int  LCDE_obtenirElement(LCDE_ListeChainee l) {
  assert(!LCDE_estVide(l));
  errno=0;
  return l->lElement;
}

LCDE_ListeChainee LCDE_obtenirListeSuivante(LCDE_ListeChainee l) {
  assert(!LCDE_estVide(l));
  errno=0;
  return l->listeSuivante;
}

void LCDE_fixerElement(LCDE_ListeChainee* pl, int e) {
  assert(!LCDE_estVide(*pl));
  errno=0;
  (*pl)->lElement=e;
}

void LCDE_fixerListeSuivante(LCDE_ListeChainee* pl, LCDE_ListeChainee suivant) {
  assert(!LCDE_estVide(*pl));
  errno=0;
  (*pl)->listeSuivante=suivant;
}

void LCDE_supprimerTete(LCDE_ListeChainee* pl){
  LCDE_ListeChainee temp;
  assert(!LCDE_estVide(*pl));
  errno=0;
  temp=*pl;
  *pl=LCDE_obtenirListeSuivante(*pl);
  free(temp);
}

void LCDE_supprimer(LCDE_ListeChainee* pl){
  errno=0;
  if (!LCDE_estVide(*pl)) {
    LCDE_supprimerTete(pl);
    LCDE_supprimer(pl);
  } 
}

LCDE_ListeChainee LCDE_copier(LCDE_ListeChainee l) {
  LCDE_ListeChainee temp;
  errno=0;
  if (LCDE_estVide(l))
    return LCDE_listeChainee();
  else {
    temp=LCDE_copier(LCDE_obtenirListeSuivante(l));
    LCDE_ajouter(&temp,LCDE_obtenirElement(l));
    return temp;
  }
}

int LCDE_egale(LCDE_ListeChainee l1,LCDE_ListeChainee l2) {
  errno=0;
  if (LCDE_estVide(l1) && LCDE_estVide(l2))
    return true;
  else {
    if (LCDE_estVide(l1) || LCDE_estVide(l2))
      return false;
    else {
      if (LCDE_obtenirElement(l1)==LCDE_obtenirElement(l2))
	return LCDE_egale(LCDE_obtenirListeSuivante(l1),LCDE_obtenirListeSuivante(l2));
      else
	return false;
    }
  }
}

