#include<stdio.h>
#include<CUnit/Basic.h>
#include<string.h>
#include"ListeChaineeDEntiers.h"

#define TRUE 1
#define FALSE 0

int init_suite_success(void) { 
  return 0; 
}

int clean_suite_success(void) { 
  return 0; 
}

LCDE_ListeChainee creer_liste_avec_1() {
  LCDE_ListeChainee l=LCDE_listeChainee();
  LCDE_ajouter(&l,1);
  return l;
}

LCDE_ListeChainee creer_liste_avec_21() { 
  LCDE_ListeChainee l=LCDE_listeChainee();
  LCDE_ajouter(&l,1);
  LCDE_ajouter(&l,2);
  return l;
}

void test_liste_vide(void){
  LCDE_ListeChainee l=LCDE_listeChainee();
  CU_ASSERT_TRUE(LCDE_estVide(l));
  LCDE_supprimer(&l);
}

void test_liste_non_vide(void){
  LCDE_ListeChainee l=creer_liste_avec_1();
  CU_ASSERT_TRUE(!LCDE_estVide(l));
  LCDE_supprimer(&l);
}

void test_element_ajoute_en_tete(void){
  LCDE_ListeChainee l=LCDE_listeChainee();
  LCDE_ajouter(&l,1);
  CU_ASSERT_EQUAL(LCDE_obtenirElement(l),1);
  LCDE_supprimer(&l);
}

void test_obtenir_liste_suivante(void){  
  LCDE_ListeChainee lSuivante;
  LCDE_ListeChainee l=LCDE_listeChainee();
  LCDE_ajouter(&l,1);
  lSuivante=l;
  LCDE_ajouter(&l,2);
  CU_ASSERT_PTR_EQUAL(LCDE_obtenirListeSuivante(l),lSuivante);
  LCDE_supprimer(&l);
}

void test_fixer_liste_suivante(void){
  LCDE_ListeChainee l1=LCDE_listeChainee();
  LCDE_ListeChainee l2=LCDE_listeChainee();
  LCDE_ListeChainee temp=LCDE_listeChainee();
  LCDE_ajouter(&l1,1);
  temp=l1;
  LCDE_ajouter(&l1,2);
  LCDE_ajouter(&l2,3);
  LCDE_fixerListeSuivante(&l1,l2);
  CU_ASSERT_PTR_EQUAL(LCDE_obtenirListeSuivante(l1),l2);
  LCDE_supprimer(&l1);
  LCDE_supprimer(&temp);
}

void test_copie_egale(void){
  LCDE_ListeChainee l1=creer_liste_avec_21();
  LCDE_ListeChainee l2=LCDE_copier(l1);
  CU_ASSERT_TRUE(LCDE_egale(l1,l2));
  LCDE_supprimer(&l1);
  LCDE_supprimer(&l2);
}

void test_differente(void){
  LCDE_ListeChainee l1=creer_liste_avec_21();
  LCDE_ListeChainee l2=creer_liste_avec_1();
  CU_ASSERT_FALSE(LCDE_egale(l1,l2));
  LCDE_supprimer(&l1);
  LCDE_supprimer(&l2);
}

int main(int argc, char** argv){
  CU_pSuite pSuite = NULL;

  /* initialisation du registre de tests */
  if (CUE_SUCCESS != CU_initialize_registry())
    return CU_get_error();

  /* ajout d'une suite de test */
  pSuite = CU_add_suite("Tests boite noire", init_suite_success, clean_suite_success);
  if (NULL == pSuite) {
    CU_cleanup_registry();
    return CU_get_error();
  }

  /* Ajout des tests  la suite de tests boite noire */
  if ((NULL == CU_add_test(pSuite, "la creation d'une liste qui doit etre vide", test_liste_vide)) 
      || (NULL == CU_add_test(pSuite, "une liste contenant un element n'est pas vide", test_liste_non_vide)) 
      || (NULL == CU_add_test(pSuite, "un element ajoute est en tete de liste", test_element_ajoute_en_tete))
      || (NULL == CU_add_test(pSuite, "obtenir liste suivante", test_obtenir_liste_suivante))  
      || (NULL == CU_add_test(pSuite, "fixer liste suivante", test_fixer_liste_suivante))  
      || (NULL == CU_add_test(pSuite, "une liste et sa copie sont egales", test_copie_egale)) 
      || (NULL == CU_add_test(pSuite, "deux listes differentes ne sont pas egales", test_differente)) 
      )
    {
      CU_cleanup_registry();
      return CU_get_error();
    }

  /* Lancement des tests */
  CU_basic_set_mode(CU_BRM_VERBOSE);
  CU_basic_run_tests();
  printf("\n");
  CU_basic_show_failures(CU_get_failure_list());
  printf("\n\n");

  /* Nettoyage du registre */
  CU_cleanup_registry();
  return CU_get_error();
}
